<?php

define('IN_FORUM',   true);
define('BB_SCRIPT', 'order');
define('BB_ROOT', './');
require(BB_ROOT .'common.php');

$user->session_start();
$page_cfg['use_tablesorter'] = true;
$mode = request_var('action', '');

$m_add = $m_def = $m_info = $m_edit = false;
$opt = '';
$ret = ' <br /><br /><a href="order.php">'. $lang['GO_BACK'] .'</a>';
$per_page = '10'; //сколько выводить заказов на каждой странице
$mod = (IS_AM) ? '' : ' AND user_id = '.$userdata['user_id'];
$selected = '';

switch($mode) {
	case 'delete':
		$id = (int) intval(request_var('id', ''));		
		if(DB()->fetch_row("SELECT * FROM bb_order WHERE id = ".$id. $mod)) {
			if(DB()->query("DELETE FROM bb_order WHERE id = '". $id ."'")) {
				if(DB()->query("DELETE FROM bb_order_vote WHERE id = '". $id ."'")) bb_die($lang['REMOVED'].$ret);
			}
		} else bb_die($lang['ORDER_DEL'].$ret);
	break;
	
	case 'edit':
		$m_add = true; $id = (int) intval(request_var('id', ''));	
		if($sql = DB()->fetch_row("SELECT * FROM bb_order WHERE id = ".$id. $mod)) {
			$selected = $sql['forum_id'];
			if(request_var('submit', '')) {		
				$title = (string) request_var('title', ''); $description = (string) request_var('description', ''); $category = (int) intval(request_var('category', ''));
				if($title && $description && $category) {				
					$array = array(
						'forum_id' => $category,
						'title' => $title,
						'description' => $description,
					);
				
					if(DB()->query("UPDATE bb_order SET ". DB()->build_array('UPDATE', $array) ." WHERE id = ".$id)) bb_die($lang['ORDER_EDIT'].$ret);
					else bb_die($lang['ERROR'].$ret);		
				} else bb_die($lang['ORDER_ERROR_EDIT'].$ret);
			} else {
				if($sql = DB()->fetch_row("SELECT o.*, u.* FROM bb_order o LEFT JOIN ". BB_USERS ." u ON(o.user_id = u.user_id) WHERE o.id = ".$id)) {
					$template->assign_vars(array(
						'TITLE'    => $sql['title'],
						'DESC'     => $sql['description'],
					));
				}
			}
		} else bb_die($lang['ORDER_ERROR_ED'].$ret);
	break;

	case 'add_id':
		$id = (int) intval(request_var('id', '')); $topic_id = (int) intval(request_var('add_id', ''));
		if(is_numeric($topic_id) && $id) {
			if(DB()->query("UPDATE bb_order SET topic_id = '". $topic_id ."', poster_id = '".$userdata['user_id']."' WHERE id = ".$id)) {
				bb_die($lang['ADDED'].$ret);
			} else bb_die($lang['ERROR'].$ret);
		} else bb_die($lang['ERROR'].$ret);	
	break;
	
	case 'info':
		$m_info = true; $id = request_var('id', '');
		if($id) {
			if($sql = DB()->fetch_row("SELECT o.*, u.* FROM bb_order o LEFT JOIN ". BB_USERS ." u ON(o.user_id = u.user_id) WHERE o.id = ".$id)) {	
				$template->assign_vars(array(
					'TITLE'    => $sql['title'],
					'VOTE'     => $sql['vote'],
					'AUTHOR'   => profile_url($sql),
					'DESC'     => $sql['description'],
					'TIME'     => bb_date($sql['time']),
					'ID'       => $sql['id'], 
					'VIEW'     => $sql['topic_id'],
				));	
			} else bb_die($lang['ORDER_NOT_FOUND'].$ret);
		} else bb_die($lang['ORDER_NOT_FOUND'].$ret);
	break;
	
	case 'add':
		$m_add = true;
		if(request_var('submit', '')) {			
			$title = (string) request_var('title', ''); $description = (string) request_var('description', ''); $category = (int) intval(request_var('category', ''));	
			if($title && $description && $category) {
				if(DB()->query("INSERT INTO bb_order (forum_id, user_id, title, description, time) VALUES ('". DB()->escape($category) ."', '".$userdata['user_id']."', '". DB()->escape($title) ."', '". DB()->escape($description) ."', '". TIMENOW ."')")) bb_die($lang['ORDER_ADD'].$ret);
				else bb_die($lang['ERROR'].$ret);	
			} else bb_die($lang['ORDER_ERROR_EDIT'].$ret);
		}	
	break;
	
	default:
		$m_def = true; $start = intval(request_var('start', 0));	
		$where = ''; $cat_id = (int) intval(request_var('category', ''));	
		$only_my = request_var('only_my', ''); $hide_filled = request_var('hide_filled', '');
		
		if($cat_id) $w[] = 'o.forum_id = '.$cat_id;
		if($only_my) $w[] = 'o.user_id = '.$userdata['user_id'];
		if($hide_filled) $w[] = 'o.poster_id = 0';
		
		if(isset($w) && is_array($w)) {
			foreach($w as $key => $val) {	
				if(!$key) $where .= ' WHERE '.$val; else $where .= ' AND '.$val;
			}
		}
		
		if($sql = DB()->fetch_rowset("SELECT o.*, u.*, u2.username AS poster_name, f.forum_name FROM bb_order o LEFT JOIN ". BB_USERS ." u ON(o.user_id = u.user_id) LEFT JOIN ". BB_USERS ." u2 ON(o.poster_id = u2.user_id) LEFT JOIN " . BB_FORUMS . " f ON(o.forum_id = f.forum_id) ".$where." ORDER BY id DESC LIMIT $start, $per_page")) {
			foreach($sql as $row) {
				$pr_ur = $row; $pr_ur['username'] = $row['poster_name']; $pr_ur['user_id'] = $row['poster_id'];
				$template->assign_block_vars('d', array(
					'TITLE'    => $row['title'],
					'ID'       => $row['id'],
					'VOTE'     => $row['vote'],
					'FORUM'    => '<a href="'. make_url(FORUM_URL . $row['forum_id']) .'">'.$row['forum_name'].'</a>',
					'TIME'     => bb_date($row['time']),
					'AUTHOR'   => profile_url($row),
					'COMPLETE' => ($row['poster_id']) ? '<a href="'.make_url(TOPIC_URL . $row['topic_id']).'">'.$lang['YES'].'</a>' : $lang['NO'],
					'POSTER'   => ($row['poster_id']) ? profile_url($pr_ur) : '',
					'AUTH_OR'  => (IS_AM || $row['user_id'] == $userdata['user_id']) ? '<a href="order.php?action=edit&id='.$row['id'].'" title="'.$lang['ORDER_T_EDIT'].'"><img src="'. make_url('styles/images/icon_edit.gif') .'"></a>&nbsp;&nbsp;<a href="order.php?action=delete&id='.$row['id'].'" title="'.$lang['ORDER_T_DEL'].'"><img src="'. make_url('styles/images/icon_delete.gif') .'"></a>' : '',
				));
			}
			
			$param = $cat_id || $only_my || $hide_filled; $prifix = ($param) ? '&' : '?'; $url = 'order.php';
			
			if($param) { 
				unset($_REQUEST['start']);
				$url .= '?'.http_build_query($_REQUEST);
			}

			generate_pagination($url, DB()->fetch_row("SELECT COUNT(id) AS count_id FROM bb_order o ".(($param) ? $where : ''))['count_id'], $per_page, $start, true, $prifix);
			
		}
}

$template->assign_vars(array(
	'PAGE_TITLE'=> 'Order',
	'MODE_ADD'  => $m_add,
	'MODE_DEF'  => $m_def,
	'MODE_INFO' => $m_info,
	'CAT' 	    => get_forum_select('user', 'category', $selected, '', '', '', '0', true),
));

print_page('order.tpl');